class MSBDataObject extends Object;

struct ComplexInfo
{
	var array<string> ButtonList;
    var array<string> Properties;
	var array<string> Values;
	var array<int> ActorReference;
	var array<int> PawnReference;
    var array<int> SpecialReference;
	var class<MSBExtendedListButton> ButtonClass;
	var int xpos;
    var int ypos;
    var color col;
    var string BtnName;
};

struct NodeInfo
{
	var array<string> ButtonList;
    var array<string> Properties;
	var array<string> Values;
	var array<int> ActorReference;
	var array<int> PawnReference;
    var array<int> SpecialReference;
	var bool bHiddenBranch;
    var int xpos;
    var int ypos;
    var color col;
    var string BtnName;
    var class<MSBScriptNode> OrderClass;
    var int NextNode;
};

struct MSBScriptNodeInfo
{
	var array<string> ButtonList;
    var array<string> Properties;
	var array<string> Values;
    var class<MSBScriptNodeButton> myClass;
	var int xpos;
    var int ypos;
    var color col;
    var string BtnName;
    var int NextNode;
};

struct ContainerInfo
{
    var array<int> containedScriptNodes;
    var array<int> containedNodes;
    var array<int> containedComplexButtons;
    var array<int> containedActors;
    var array<int> containedPawns;
    var array<int> containedContainers;
    var array<int> containedSpecial;
    var class<MSBContainerButton> myClass;

    var bool bCollapsed;
    var int xpos;
    var int ypos;
    var color col;
    var string BtnName;
};

struct ActorInfo
{
	var array<string> ButtonList;
    var array<string> Properties;
	var array<string> Values;
    var array<int> Keyframes;
    var vector Location;
    var rotator Rotation;
    var vector DrawScale3D;
    var float DrawScale;
	var class<MSBActor> ActorClass;
	var string content;
    var int attachedTo;
    var int attachedToPawn;
    var int attachedToSpecial;
    var name Tag;

	var array<int> ActorReference;
	var array<int> PawnReference;
    var array<int> SpecialReference;

    var array<vector> BlockRelLocation;
    var array<color> Col;
    var array<float> DrawingScale;
};

struct PawnInfo
{
	var string PoseName[16];
    var int channel;
    var int UdpPadChannel;
    var string content;
    var class<Actor> InputControlClass;
    var array<string> ButtonList;
    var array<string> Properties;
	var array<string> Values;
    var vector Location;
    var rotator Rotation;
    var vector DrawScale3D;
    var float DrawScale;
	var class<MSBPawn> PawnClass;
    var int attachedTo;
    var int attachedToActor;
    var int attachedToSpecial;
};

struct SpecialInfo
{
    var vector Location;
    var rotator Rotation;
};

struct Drawing
{
};

var array<ComplexInfo> myComplexInfos;
var array<NodeInfo> myNodeInfos;
var array<MSBScriptNodeInfo> myMSBScriptNodeInfos;
var array<ContainerInfo> myContainerInfos;
var array<ActorInfo> myActorInfos;
var array<PawnInfo> myPawnInfos;
var array<SpecialInfo> mySpecialInfos;
var array<Drawing> myDrawings;

var vector pcLocation;
var rotator pcRotation;
var string SaveName;


