//-----------------------------------------------------------
//  Copyright 2006 Friedrich Kirschner
//-----------------------------------------------------------

class MSBNodeButton extends MSBListButton;

var MSBNodeInButton NodeIn;
var MSBNodeOutButton NodeOut;

var MSBScriptNode Order;

var bool bHiddenBranch;
var bool hasClickedAgain;
var bool bhideBranch;
var bool bLoop;

var float xDist,yDist,oldMousexPos,oldMouseyPos;

var array<string> Properties;

var Material MatHighlight;
var array<Actor> FocusActor;

event PostBeginPlay()
{
M=MSBController(Level.getLocalPlayerController());
M.LevelNodes[M.LevelNodes.Length]=self;

NodeIn=Spawn(class'MSBNodeInButton');
NodeIn.myNode=self;
NodeOut=Spawn(class'MSBNodeOutButton',self,,M.Location);
NodeOut.myNode=self;
NodeOut.col=col;
super.PostBeginPlay();
}

function MouseOver(Canvas C)
{
local int i,j;
local string ObjectName, MapName;

super.MouseOver(C);
if (bEnabled && bOver)  //do not visually reference Actors when only being selected!
  {
  for (i=0;i<ButtonList.length;i++)
   {
    if (Caps(ButtonList[i])=="MSBPROPERTYBUTTONS.MSBPROPERTYBUTTON3D")
      {
      ObjectName=Order.GetPropertyText(Properties[i]);
      ObjectName=GetItemName(ObjectName);
      ObjectName-="'";
      MapName=Left(string(Level), InStr(string(Level), "."));
      ObjectName=MapName$"."$ObjectName;
      FocusActor[j]=Actor(FindObject(ObjectName,class'Actor'));
      if (FocusActor[j]!=None)
        {
        if (M.pointers.length==j)
          M.pointers[j]=Spawn(class'MSBPointActor',,,Location);
        M.pointers[j].SetLocation(FocusActor[j].Location);
        M.pointers[j].bHidden=false;
        j++;
        }
      }
    if (Order.IsA('MSBRootNode'))
        {
        M.pointers[j].SetLocation(MSBRootNode(Order).BasePawn.Location);
        M.pointers[j].bHidden=false;
        }

    }
  }
}

function IsSelected(Canvas C)
{
local int i;

C.SetDrawColor(overlayCol.R,overlayCol.G, overlayCol.B, overlayCol.A);
C.SetPos(xPos,yPos);
if (Mat!=None)
  C.DrawTile(Mat,width,height,0,0,U,V);

for (i=0;i<Mouse.selectedButtons.Length;i++)
  if (Mouse.selectedButtons[i]!=None && Mouse.selectedButtons[i]==self)
    return;
Mouse.selectedButtons[i]=self;
}

function initButton(Canvas C)
{

xDist=Mouse.xPos-oldMousexPos;
yDist=Mouse.yPos-oldMouseyPos;

oldMousexPos=Mouse.xPos;
oldMouseyPos=Mouse.yPos;

if (bDragged)
  {
  xPos=xPos+xDist;
  yPos=yPos+yDist;
  }

super.initButton(C);

C.SetPos(xPos,yPos);
C.SetDrawColor(textCol.R,textCol.G,textCol.B);
C.DrawText(BtnName);
C.SetDrawColor(col.R,col.G,col.B);

if (bEnabled)
 {
 if (hasClicked && Mouse.btnOne)
   {
   hasClickedAgain=true;
   LeftBtnFinished(C);
   hasClickedAgain=false;
   }
 }
}

function RightBtn(Canvas C)
{
local int i;

super.LeftBtn(C);
for (i=0;i<Buttonlist.Length; i++)
  {
   MSBPropertyButton(ListButton[i]).Parent=self;
   MSBPropertyButton(ListButton[i]).Property=Properties[i];
  }
propagateBaseActor();
}

function LeftBtn(Canvas C)
{
local int i;

super.RightBtn(C);
bDragged=true;
//start dragging the whole list of selected Buttons
for (i=0;i<Mouse.selectedButtons.Length;i++)
     Mouse.selectedButtons[i].bDragged=true;
}

function LeftBtnFinished(Canvas C)
{
local int i;

hasClicked=false;
//enable all other buttons after second press
for (i=0;i<M.myHud.Overlays.Length-1;i++)
  if (M.myHud.Overlays[i].IsA('MSBGuiOverlay'))
    MSBGuiOverlay(M.myHud.Overlays[i]).bEnabled=true;

Mouse.btnOne=false;

for (i=0;i<Mouse.selectedButtons.Length;i++)
    Mouse.selectedButtons[i].bDragged=false;
bDragged=false;
}

function hideNode()
{
bHiddenBranch=true;
M.myHUD.RemoveHudOverlay(NodeOut);
M.myHUD.RemoveHudOverlay(NodeIn);
M.myHUD.RemoveHudOverlay(self);
}

function showNode()
{
local HudOverlay mOverlay;

mOverlay=M.myHUD.Overlays[M.myHUD.Overlays.Length-1]; // POP Mouse from Overlay Stack
M.myHUD.RemoveHudOverlay(mOverlay);
M.myHUD.AddHudOverlay(self);
if (NodeIn!=None)
  M.myHUD.AddHudOverlay(NodeIn);
M.myHUD.AddHudOverlay(NodeOut);
M.myHUD.AddHudOverlay(mOverlay);            //PUSH Mouse back on top
bHiddenBranch=false;
}

function propagateBaseActor()
{
local int i;
local Pawn P;

if (crawlUp(P, self))
 for (i=0;i<Properties.length;i++)
   if (Properties[i]=="AssignTo")
     {
     Order.SetPropertyText("AssignTo",string(P));
     ListButton[i].deSelect();
     ListButton[i].Destroy();
     }
}


function bool crawlUp(out Pawn P, MSBNodeButton N)
{

if (N.NodeIn==None && N.Order.IsA('MSBRootNode'))
  return true;

if (N.NodeIn.ParentNode==None)
  return false;

if (N.NodeIn.ParentNode.myScript!=None)
  return false;

if (N.NodeIn.ParentNode.myNode.Order.IsA('MSBRootNode'))
 {
 P=MSBRootNode(N.NodeIn.ParentNode.myNode.Order).BasePawn;
 return true;
 }
else if (N.NodeIn.ParentNode!=None)
  {
  if(!N.bLoop)
    return crawlUp(P,N.NodeIn.ParentNode.myNode);
  }
return false;
}

defaultproperties
{
widthRel=70
heightRel=18
Mat=Texture'MoviesandboxTextures.icon_node'
MatHighLight=Material'MovieSandboxTextures.TransRed'
BtnName="Node"
ypos=100
xpos=100
ButtonList(0)=None;
col=(R=225,G=225,B=255,A=255)
}

