class MSBEmitter extends Emitter;

var StaticMesh myStaticMesh;
var ParticleEmitter P;
var Texture myTexture;

event PostBeginPlay()
{
super.PostBeginPlay();
MeshEmitter(Emitters[0]).StaticMesh=myStaticMesh;
SpriteEmitter(Emitters[1]).Texture=myTexture;
//Emitters[0].SpawnParticle(5000);
P=Emitters[1];
}

event Trigger(Actor Other, Pawn Eventinstigator)
{
SetTimer(0.1,false);
P.SpawnParticle(100);
}

event Timer()
{
local int i,j;

Log("distributing...");
for(i=0;i<10;i++)
 for(j=0;j<10;j++)
  {
  P.Particles[i].Location.X=i*8;
  P.Particles[i].Location.Y=j*8;
  }
}


defaultproperties
{
    Begin Object Class=MeshEmitter Name=MeshEmitter0
        MaxParticles=2048
        LifeTimeRange=(Min=100000000000,Max=100000000000)
        ParticlesPerSecond=0
        InitialParticlesPerSecond=0
        CoordinateSystem=PTCS_Relative
       	StartSizeRange=(X=(Min=0.1,Max=0.1),Y=(Min=0.1,Max=0.1),Z=(Min=0.1,Max=0.1))
       	UseParticleColor=true
       	UniformSize=false
       	AcceptsProjectors=true
        RespawnDeadParticles=true
    End Object

    Begin Object Class=SpriteEmitter Name=SpriteEmitter0
        MaxParticles=4096
        MaxActiveParticles=4096
        LifeTimeRange=(Min=100000000000,Max=100000000000)
        ParticlesPerSecond=0
        Opacity=0.5
        InitialParticlesPerSecond=0
        CoordinateSystem=PTCS_Relative
       	StartSizeRange=(X=(Min=0.1,Max=0.1),Y=(Min=0.1,Max=0.1),Z=(Min=1,Max=1))
        UniformSize=false
        UseSizeScale=false
        DrawStyle=PTDS_Regular
        AcceptsProjectors=true
        UseDirectionAs=PTDU_None
        RespawnDeadParticles=true

        AlphaTest=true
        ZTest=true
        ZWrite=true

        ProjectionNormal=(X=0,Y=0,Z=1)
    End Object

Emitters(0)=MeshEmitter'MSBEmitter.MeshEmitter0'
Emitters(1)=SpriteEmitter'MSBEmitter.SpriteEmitter0'


bNoDelete=false
bStatic=false
myTexture=Texture'MoviesandboxTextures.roundbrush'
//myTexture=Texture'MoviesandboxTextures.pencil_dark_A01'

myStaticMesh=StaticMesh'MoviesandboxMeshes.helperMeshes.CubeWhiteSided'

UseParticleProjectors=true
}

/*
Just an example emitter that works with projections...

Begin Map
Begin Actor Class=Emitter Name=Emitter38
    Begin Object Class=SpriteEmitter Name=SpriteEmitter38
        ProjectionNormal=(Y=1.000000,Z=0.000000)
        ResetAfterChange=True
        RespawnDeadParticles=False
        AcceptsProjectors=True
        ZWrite=True
        UniformSize=True
        AutomaticInitialSpawning=False
        ColorScale(0)=(Color=(A=128))
        ColorScale(1)=(RelativeTime=1.000000,Color=(A=128))
        FadeOutStartTime=4.000000
        FadeInEndTime=0.100000
        CoordinateSystem=PTCS_Relative
        MaxParticles=4096
        EffectAxis=PTEA_PositiveZ
        StartLocationRange=(X=(Min=-200.000000,Max=200.000000),Z=(Min=-200.000000,Max=200.000000))
        StartSizeRange=(X=(Min=5.000000,Max=5.000000),Y=(Min=5.000000,Max=5.000000))
        InitialParticlesPerSecond=200000.000000
        DrawStyle=PTDS_Regular
        Texture=Texture'XGame.Water.xCausticRing2'
        LifetimeRange=(Min=100000.000000,Max=100000.000000)
    End Object
    Emitters(0)=SpriteEmitter'myLevel.SpriteEmitter38'

    Level=LevelInfo'myLevel.LevelInfo0'
    Region=(Zone=LevelInfo'myLevel.LevelInfo0',ZoneNumber=1)
    Tag="Emitter"
    PhysicsVolume=DefaultPhysicsVolume'myLevel.DefaultPhysicsVolume6'
    Location=(X=152.951218,Y=144.263657,Z=-49.000000)
    bSelected=True
End Actor
Begin Surface
End Surface
End Map
*/
