#exec OBJ LOAD FILE=MovieSandboxMeshes.usx

class MSBProjector extends MSBActor;

var DynamicProjector myProjector;
var string DecalMaterial;
var bool bDisabled;
var Actor LinkTo;

event PostBeginPlay()
{
super.PostBeginPlay();
myProjector=Spawn(class'DynamicProjector',self,,self.location,self.rotation);
myProjector.FrameBufferBlendingOp=PB_AlphaBlend;
myProjector.MaterialBlendingOp=PB_AlphaBlend;
myProjector.bClipBSP=true;
myProjector.bClipStaticMesh=true;
myProjector.bProjectActor=false;
myProjector.bProjectParticles=true;
myProjector.FOV=1;
myProjector.ProjectTag=Name;
}

function Tick(float DeltaTime)
{
super.Tick(DeltaTime);

if (string(myProjector.ProjTexture)!=DecalMaterial)
  myProjector.ProjTexture=Texture(DynamicLoadObject(DecalMaterial,class'Texture'));

myProjector.SetLocation(Location);
myProjector.SetRotation(Rotation);

if (LinkTo!=None)
 {

 LinkTo.Tag=Name;
 myProjector.bProjectParticles=true;
 if (LinkTo.IsA('MSBMAsterBlock') && MSBMasterBlock(LinkTo).E!=None)
   MSBMasterBlock(LinkTo).E.Tag=Name;
 }
}

event Destroyed()
{
myProjector.Destroy();
super.Destroyed();
}

event Trigger(Actor Other, Pawn EventInstigator)
{
super.Trigger(Other, EventInstigator);

bDisabled=!bDisabled;

if (bDisabled)
  {
  myProjector.bProjectBSP=false;
  myProjector.bProjectOnParallelBSP=false;
  myProjector.bProjectOnBackfaces=false;
  myProjector.bProjectStaticMesh=false;
  myProjector.bProjectActor=false;
  myProjector.bProjectParticles=false;
  }
else
  {
  myProjector.bProjectBSP=true;
  myProjector.bProjectOnParallelBSP=true;
  myProjector.bProjectOnBackfaces=true;
  myProjector.bProjectStaticMesh=true;
  myProjector.bProjectActor=false;
  myProjector.bProjectParticles=true;
  }

Log(bDisabled@"Triggered...");
}

defaultproperties
{
ButtonList(4)="MSBPropertyButtons.MSBPropertyButtonText"
Properties(4)="DecalMaterial"
ButtonList(5)="MSBPropertyButtons.MSBPropertyButtonAttachToBone"
Properties(5)="Dummy"
ButtonList(6)="MSBPropertyButtons.MSBPropertyButtonAssign"
Properties(6)="Trigger"

ButtonList(7)="MSBPropertyButtons.MSBPropertyButton3D"
Properties(7)="LinkTo"


DecalMaterial="MovieSandboxTextures.ruler"

bDisplayed=false

DrawType=DT_StaticMesh
StaticMesh=StaticMesh'MoviesandboxMeshes.helperMeshes.arrowWhite'
content="MoviesandboxMeshes.helperMeshes.arrowWhite"
Skins(0)=Material'MovieSandboxTextures.red'
Drawscale=3
bStatic=false
bNoDelete=false
bHidden=false

Physics=PHYS_None

bDirectional=True

CollisionRadius=16.0
CollisionHeight=16.0

bUseCylinderCollision=true
bCollideActors=True
bBlockActors=False
bCollideWorld=True
bProjTarget=True
Texture=S_LookTarget
}
