class MSBRDPuppetInputControl extends Actor;

var MSBRagDollPuppet myPuppet;

var MSBUdpLink udpLinkFeet;
var MSBUdpLink udpLinkHead;
var MSBUdpLink udpLinkHands;


var () int iPort;   // server port number
var bool bUdpInit;
var () vector leftDown, rightUp, leftDownTwo, rightUpTwo;

var bool bHeadUp,bHeadDown,bFluffy;

event PostBeginPlay()
{
super.PostBeginPlay();
if (Owner.IsA('MSBRagdollPuppet'))
  myPuppet=MSBRagdollPuppet(Owner);
}

function initFeetUdp()
{
 iPort=31840+myPuppet.UdpPadCh;
 if (udpLinkFeet!=None)
   udpLinkFeet.Destroy();
 if (myPuppet.UdpPadCh>0)
   {
   udpLinkFeet=Spawn(class'MSBUdpLink',self);
   udpLinkFeet.InitUdpLink(iPort);
   Log("UdpPort initialized to"@iPort);
   }
 else
   Log("udpLinkFeet destroyed");
}

function initHeadUdp()
{
 iPort=31840+myPuppet.UdpHeadPadCh;
 if (udpLinkHead!=None)
   udpLinkHead.Destroy();
 if (myPuppet.UdpHeadPadCh>0)
   {
   udpLinkHead=Spawn(class'MSBUdpLink',self);
   udpLinkHead.InitUdpLink(iPort);
   Log("UdpHeadPort initialized to"@iPort);
   }
}

function initHandsUdp()
{
 iPort=31840+myPuppet.UdpHandsPadCh;
 if (udpLinkHands!=None)
   udpLinkHands.Destroy();
 if (myPuppet.UdpHandsPadCh>0)
   {
   udpLinkHands=Spawn(class'MSBUdpLink',self);
   udpLinkHands.InitUdpLink(iPort);
   Log("UdpHandsPort initialized to"@iPort);
   }
}

event Trigger(Actor Other,Pawn EventInstigator)
{
//general data stuff
local rotator pOneRot, offset;
local float dataOne;
local float pOneLength;
local vector pOne,X,Y,Z;

//feet and Walking
local vector deltaFeet;
local bool bRightFoot,bIsInStep,bFinishedStep;


if (Other.IsA('MSBGuiOverlay'))
  {
  initFeetUdp();
  initHeadUdp();
  Log("changed UdpPadChannel in MSBRDPuppetInputControl!");
  }

//udp GameTrak_

//cleanup
if (myPuppet!=None)
  {
  myPuppet.neckLoc=0*myPuppet.neckLoc;
  myPuppet.spineLoc=0*myPuppet.neckLoc;
  myPuppet.leftHandLoc=0*myPuppet.neckLoc;
  myPuppet.rightHandLoc=0*myPuppet.neckLoc;
  myPuppet.leftFootLoc=0*myPuppet.neckLoc;
  myPuppet.rightFootLoc=0*myPuppet.neckLoc;
  }

//********************************************
// Hands
if (myPuppet!=None && myPuppet.UdpHandsPadCh>0 && Other==udpLinkHands && myPuppet.bRunning)
  {
  myPuppet.GetAxes(mypuppet.rotation,X,Y,Z);
  offset.Pitch=16384;

  //calculate Gametrak positions from rotation
  dataOne=(UdpLinkHands.byteData[6] << 8)+ UdpLinkHands.byteData[7] - 32767;
  dataOne=(dataOne/32768)*5461;
  pOneRot.Yaw=-dataOne;

  dataOne=(UdpLinkHands.byteData[8] << 8)+ UdpLinkHands.byteData[9] - 32767;
  dataOne=(dataOne/32768)*5461;
  pOneRot.Pitch=dataOne;


  pOneLength=65536 -((UdpLinkHands.byteData[10] << 8) + UdpLinkHands.byteData[11]) ;
  pOne=vector(pOneRot)*((pOneLength/255));
  pOne=pOne >> offset;

  myPuppet.leftHandLoc.X=-pOne.X*5+4;
  myPuppet.leftHandLoc.Y=(-pOne.Y*5)-12;
  myPuppet.leftHandLoc.Z=pOne.Z*2-24;

  if (myPuppet.leftHandLoc.X<leftDown.X)
    myPuppet.leftHandLoc.X=leftDown.X;
  if (myPuppet.leftHandLoc.Y<leftDown.Y)
    myPuppet.leftHandLoc.Y=leftDown.Y;
  if (myPuppet.leftHandLoc.Z<leftDown.Z)
    myPuppet.leftHandLoc.Z=leftDown.Z;
  if (myPuppet.leftHandLoc.X>rightUp.X)
    myPuppet.leftHandLoc.X=rightUp.X;
  if (myPuppet.leftHandLoc.Y>rightUp.Y)
    myPuppet.leftHandLoc.Y=rightUp.Y;
  if (myPuppet.leftHandLoc.Z>rightUp.Z)
    myPuppet.leftHandLoc.Z=rightUp.Z;

  myPuppet.leftHandLoc=-myPuppet.leftHandLoc.X*X-myPuppet.leftHandLoc.Y*Y+myPuppet.leftHandLoc.Z*Z;

  dataOne=(UdpLinkHands.byteData[0] << 8)+ UdpLinkHands.byteData[1] - 32767;
  dataOne=(dataOne/32768)*5461;
  pOneRot.Yaw=-dataOne;

  dataOne=(UdpLinkHands.byteData[2] << 8)+ UdpLinkHands.byteData[3] - 32767;
  dataOne=(dataOne/32768)*5461;
  pOneRot.Pitch=dataOne;


  pOneLength=65536 -((UdpLinkHands.byteData[4] << 8) + UdpLinkHands.byteData[5]) ;
  pOne=vector(pOneRot)*((pOneLength/255));
  pOne=pOne >> offset;

  myPuppet.rightHandLoc.X=-pOne.X*5+4;
  myPuppet.rightHandLoc.Y=-pOne.Y*5+12;
  myPuppet.rightHandLoc.Z=pOne.Z*2-24;

  if (myPuppet.rightHandLoc.X<leftDownTwo.X)
    myPuppet.rightHandLoc.X=leftDownTwo.X;
  if (myPuppet.rightHandLoc.Y<leftDownTwo.Y)
    myPuppet.rightHandLoc.Y=leftDownTwo.Y;
  if (myPuppet.rightHandLoc.Z<leftDownTwo.Z)
    myPuppet.rightHandLoc.Z=leftDownTwo.Z;

  if (myPuppet.rightHandLoc.X>rightUpTwo.X)
    myPuppet.rightHandLoc.X=rightUpTwo.X;
  if (myPuppet.rightHandLoc.Y>rightUpTwo.Y)
    myPuppet.rightHandLoc.Y=rightUpTwo.Y;
  if (myPuppet.rightHandLoc.Z>rightUpTwo.Z)
    myPuppet.rightHandLoc.Z=rightUpTwo.Z;

  myPuppet.rightHandLoc=-myPuppet.rightHandLoc.X*X-myPuppet.rightHandLoc.Y*Y+myPuppet.rightHandLoc.Z*Z;
  }

//***********************************
//Head

if (myPuppet!=None && myPuppet.UdpHeadPadCh>0 && Other==udpLinkHead && myPuppet.bRunning)
  {
  myPuppet.GetAxes(mypuppet.rotation,X,Y,Z);
//  pOne.X=udpLinkHead.byteData[0]-128;
  pOne.Y=-(udpLinkHead.byteData[0]-128)/4;
  pOne.Z=-(udpLinkHead.byteData[1]-128) /4;

 // myPuppet.neckLoc.X=-pOne.X;
  myPuppet.neckLoc.Y=pOne.Y;
  myPuppet.neckLoc.Z=pOne.Z;

  myPuppet.neckLoc=-myPuppet.neckLoc.X*X-myPuppet.neckLoc.Y*Y+myPuppet.neckLoc.Z*Z;
  }

//********************************************
// Feet
if (myPuppet!=None && myPuppet.UdpPadCh>0 && Other==udpLinkFeet && myPuppet.bRunning)
  {
  //calculate Gametrak positions from rotation
  offset.Pitch=16384;
  dataOne=(UdpLinkFeet.byteData[6] << 8)+ UdpLinkFeet.byteData[7] - 32767;
  dataOne=(dataOne/32768)*5461;
  pOneRot.Yaw=-dataOne;

  dataOne=(UdpLinkFeet.byteData[8] << 8)+ UdpLinkFeet.byteData[9] - 32767;
  dataOne=(dataOne/32768)*5461;
  pOneRot.Pitch=dataOne;

  //leftFoot
  pOneLength=65536 -((UdpLinkFeet.byteData[10] << 8) + UdpLinkFeet.byteData[11]) ;
  pOne=vector(pOneRot)*((pOneLength/255));
  pOne=pOne >> offset;
  myPuppet.leftFootLoc=pOne;
  myPuppet.leftFootLoc.X*=6;
//  myPuppet.leftFootLoc.Y*=4;

    //calculate Gametrak positions from rotation
  offset.Pitch=16384;
  dataOne=(UdpLinkFeet.byteData[0] << 8)+ UdpLinkFeet.byteData[1] - 32767;
  dataOne=(dataOne/32768)*5461;
  pOneRot.Yaw=-dataOne;

  dataOne=(UdpLinkFeet.byteData[2] << 8)+ UdpLinkFeet.byteData[3] - 32767;
  dataOne=(dataOne/32768)*5461;
  pOneRot.Pitch=dataOne;

  //rightFoot
  pOneLength=65536 -((UdpLinkFeet.byteData[4] << 8) + UdpLinkFeet.byteData[5]) ;
  pOne=vector(pOneRot)*((pOneLength/255));
  pOne=pOne >> offset;
  myPuppet.rightFootLoc=pOne;
  myPuppet.rightFootLoc.X*=6;

// determine active step and active foot
  if (myPuppet.rightFootLoc.Z>myPuppet.leftFootLoc.Z)
    bRightfoot=true;

  if (myPuppet.rightFootLoc.Z>8)
   {
   bIsInStep=true;
   bFinishedStep=false;
   Log("yay!");
   }
  else
   {
   bIsInStep=false;
   bFinishedStep=true;
   Log("calledElse");
   }

  if (myPuppet.leftFootLoc.Z>8)
   {
   Log("leftYay!");
   bIsInStep=true;
   bFinishedStep=false;
   }
  else if (!bRightFoot)
   {
   bIsInStep=false;
   bFinishedStep=true;
   Log("calledElseLeft");
   }

  //body
  deltaFeet.X=Abs(myPuppet.rightFootLoc.X-myPuppet.leftFootLoc.X);

  myPuppet.rightFootLoc=myPuppet.rightFootLoc >> myPuppet.Rotation;
  myPuppet.leftFootLoc=myPuppet.leftFootLoc >> myPuppet.Rotation;

  Log("Step:"@bIsInStep@"Finish:"@bFinishedStep@"delta:"@deltaFeet.X@"left:"@myPuppet.leftFootLoc.Z@"right:"@myPuppet.rightFootLoc.Z);

  myPuppet.spineLoc+=deltaFeet/2;
  myPuppet.leftHandLoc+=deltaFeet/2;
  myPuppet.rightHandLoc+=deltaFeet/2;
  myPuppet.neckLoc+=deltaFeet/2;

  if (bFinishedStep)
    {
    deltaFeet=deltaFeet >> myPuppet.Rotation;

    myPuppet.generalDelta=deltaFeet;


    myPuppet.Move(deltaFeet);
    myPuppet.Puppet.Move(deltaFeet);

    bFinishedStep=false;
   }

  // finishedStep: set deltaFeet to generalDelta and every other Loc to -delta/2
  //
  }
}

event Destroyed()
{
udpLinkFeet.Destroy();
udpLinkHands.Destroy();
udpLinkHead.Destroy();
}

defaultproperties
{
leftDown=(X=-32,Y=-36,Z=-12)
rightUp=(X=0,Y=6,Z=54)
leftDownTwo=(X=-32,Y=-6,Z=-12)
rightUpTwo=(X=0,Y=36,Z=54)

DrawType=DT_None
iPort=31840

//bContactingLevel!!!!
}
