//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBRagDollPuppet extends MSBActor;

const points=9;
var MSBRagdoll Puppet;
var MSBKActor PuppetControl[points];
var MSBKBSJoint Glue[points];
var Sound clapSound;
var bool bClapped;
var vector initialPuppetLocation;
var rotator initialPuppetRotation;
var KSimParams initialKSim;
var KRigidBodyState initialRBState;

var vector leftHandLoc,rightHandLoc,rightFootLoc,leftFootLoc,neckLoc,spineLoc, generalDelta;

var bool bRunning;
var int UdpHeadPadCh, UdpHandsPadCh;

event PostBeginPlay()
{
local int i;

super.PostBeginPlay();

//create the Puppet
Puppet=Spawn(class'MSBRagdoll',self,,Location,Rotation);
Puppet.KGetSimParams(initialKSim);
Puppet.KGetRigidBodyState(initialRBState);

//create the PuppetControls
for (i=0;i<points;i++)
  {
  PuppetControl[i]=Spawn(class'MSBKActor',self,,Location,Rotation);
  Glue[i]=Spawn(class'MSBKBSJoint',self,,Location,Rotation);
  Glue[i].KConstraintActor1=Puppet;
  Glue[i].KConstraintActor2=PuppetControl[i];
  }
AttachBoneStuff();

puppet.setMSBMasterBlocks();
}

function LoadCharacter()
{
puppet.content=content;
puppet.LoadProp();
}

function Tick(float DeltaTime)
{
//0=leftHand
//1=rightHand


if (bRunning)
  {
  PuppetControl[2].bHidden=false;
  PuppetControl[3].bHidden=false;
  PuppetControl[4].bHidden=false;
  PuppetControl[5].bHidden=false;
  PuppetControl[6].bHidden=false;
  PuppetControl[7].bHidden=false;
  PuppetControl[8].bHidden=false;
  PuppetControl[1].bHidden=false;
  PuppetControl[0].bHidden=false;

  PuppetControl[0].loc=generalDelta+leftHandLoc;
  PuppetControl[1].loc=generalDelta+rightHandLoc;
  PuppetControl[2].loc=generalDelta+neckloc;

  PuppetControl[3].loc=generalDelta+spineLoc;
  PuppetControl[4].loc=generalDelta+spineLoc;
  PuppetControl[5].loc=generalDelta+spineLoc;
  PuppetControl[6].loc=generalDelta+spineLoc;

  PuppetControl[7].loc=generalDelta+leftFootLoc;
  PuppetControl[8].loc=generalDelta+rightFootLoc;
  }
}

event Trigger(Actor Other, Pawn EventInstigator)
{
if (Other.IsA('MSBGuiOverlay'))
  MSBInputControl.Trigger(Other,None);
}

function RunMovie()
{
local int i;

super.RunMovie();
self.DetachFromBone(Puppet);
initialPuppetLocation=Puppet.Location;


Puppet.SetPhysics(PHYS_KarmaRagDoll);

for (i=0;i<points;i++)
  {
  PuppetControl[i].SetPhysics(PHYS_Karma);
  Glue[i].SetPhysics(PHYS_Karma);
  PuppetControl[i].TriggerEvent('RunMovie',self,None);
  PuppetControl[i].bHidden=true;
  }

bRunning=true;
SetCollision(false,false);
}

function Reset()
{
local int i;
Log(Location@Puppet.Location);
super.Reset();
Log("Reset:"@Puppet.Location);

for (i=0;i<points;i++)
  {
  Glue[i].SetPhysics(PHYS_None);
  Glue[i].bHidden=false;
  PuppetControl[i].SetPhysics(PHYS_None);
  PuppetControl[i].bHidden=false;
  }

Log("NoPhysics:"@Puppet.Location);
bRunning=false;

Puppet.SetPhysics(PHYS_None);
Puppet.KSetSimParams(initialKSim);
SetCollision(true,false);
AttachBoneStuff();
Puppet.SetLocation(initialLocation);
self.AttachToBone(Puppet,'');
Log("Attach:"@Puppet.Location);
}

function AttachBoneStuff()
{
self.AttachToBone(Puppet,'');

Puppet.AttachToBone(Glue[0],'Bip01 L Hand');
Puppet.AttachToBone(PuppetControl[0],'Bip01 L Finger0');

Puppet.AttachToBone(Glue[1],'Bip01 R Hand');
Puppet.AttachToBone(PuppetControl[1],'Bip01 R Finger0');

Puppet.AttachToBone(Glue[2],'Bip01 Head');
Puppet.AttachToBone(PuppetControl[2],'Bip01 Head');

Glue[2].SetRelativeLocation(vect(0,-25,0));
PuppetControl[2].SetRelativeLocation(vect(0,-50,0));

Puppet.AttachToBone(Glue[3],'Bip01 Spine');
Puppet.AttachToBone(PuppetControl[3],'Bip01 Spine');

Puppet.AttachToBone(Glue[4],'Bip01 Spine2');
Puppet.AttachToBone(PuppetControl[4],'Bip01 Spine2');

Puppet.AttachToBone(Glue[5],'Bip01 R Clavicle');
Puppet.AttachToBone(PuppetControl[5],'Bip01 R UpperArm');

Puppet.AttachToBone(Glue[6],'Bip01 L Clavicle');
Puppet.AttachToBone(PuppetControl[6],'Bip01 L UpperArm');

Puppet.AttachToBone(Glue[7],'Bip01 L Foot');
Puppet.AttachToBone(PuppetControl[7],'Bip01 L Foot');

Puppet.AttachToBone(Glue[8],'Bip01 R Foot');
Puppet.AttachToBone(PuppetControl[8],'Bip01 R Foot');
}

event Destroyed()
{
local int i;
for (i=0;i<points;i++)
  {
  Glue[i].Destroy();
  PuppetControl[i].Destroy();
  Puppet.Destroy();
  }
MSBInputControl.Destroy();
}

function clearActor()
{
Puppet.clearPawn();
}

DefaultProperties
{
ButtonList(3)="MSBPropertyButtons.MSBPropertyButtonText"
Properties(3)="UdpPadCh"
ButtonMat(3)="MoviesandboxTextures.icon_puppet"

ButtonList(5)="MSBPropertyButtons.MSBPropertyButtonText"
Properties(5)="UdpHeadPadCh"
ButtonMat(5)="MoviesandboxTextures.icon_puppet2"

CollisionRadius=32.0
CollisionHeight=32.0
bInputControlled=true
InputControlClassName="MSBObjects.MSBRDPuppetInputControl"
bDisplayed=false

clapSound=Sound'PlayerSounds.BFootstepWood2'
}
