//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBPropertyButtonScale extends MSBPropertyButton;

var float chgScale;

var float oldX,
          oldY;

var EPhysics OldPhysics;
var vector originalLocation;

var float originalCollisionHeight;

function Render(Canvas C)
{
local vector myLocation;
local bool canMove;
local MSBNodeButton N;

super.Render(C);
if (bEnabled)
 {
  if (bDragged)
    {
    chgScale=(Mouse.xPos-oldX);
    chgScale-=(Mouse.yPos-oldY);

    if (chgScale< 0)
      chgScale=-0.01;
    if (chgScale>0)
      chgScale=0.01;

    Parent.SetPhysics(PHYS_None);

    if (Parent.IsA('MSBMasterBlock'))
      MSBMasterBlock(Parent).scaleMe(chgScale);

    Parent.SetDrawScale(Parent.DrawScale+chgScale);
    Parent.SetCollisionSize(Parent.DrawScale*Parent.default.CollisionRadius,Parent.DrawScale*Parent.default.CollisionHeight);

    myLocation=originalLocation;
    myLocation.Z=originalLocation.Z+Parent.CollisionHeight-originalCollisionHeight;
    canMove=Parent.SetLocation(myLocation);

    //set initialLocation in corresponding RootNode!!!
    if (Parent.IsA('Pawn'))
      foreach AllActors(class'MSBNodeButton',N)
        if (N.Order.IsA('MSBRootNode') && MSBRootNode(N.Order).BasePawn==Pawn(Parent))
          MSBRootNode(N.Order).initialLocation=Parent.Location;

    if (Parent.IsA('MSBVoxelPawn'))
      MSBVoxelPawn(Parent).scaleMe(chgScale);

    M.debugString="Loc:"@myLocation.Z@Parent.Location.Z@canMove@Parent.Physics;

    Mouse.xPos=oldX;
    Mouse.yPos=oldY;
    chgScale=0;
    }

 if (hasClicked && Mouse.btnOne)
    {
    hasClickedAgain=true;
    LeftBtnFinished(C);
    hasClickedAgain=false;
    }
 }
}

function LeftBtn(Canvas C)
{
super.LeftBtn(C);
bDragged=true;
Mouse.bHitActors=false;
oldX=Mouse.xPos;
oldY=Mouse.yPos;
OldPhysics=Parent.Physics;
M.disableMidLayer();
originalLocation=Parent.Location;
originalCollisionHeight=Parent.CollisionHeight;
}

function LeftBtnFinished(Canvas C)
{
local int i;
local MSBNodeButton N;

HasClicked=false;
//enable all other buttons after second press
for (i=0;i<M.myHud.Overlays.Length-1;i++)
  if (M.myHud.Overlays[i].IsA('MSBGuiOverlay'))
    MSBGuiOverlay(M.myHud.Overlays[i]).bEnabled=true;

Mouse.btnOne=false;
bDragged=false;

//if we scale a Pawn, then set Collision appropriately

Parent.SetPhysics(OldPhysics);
Mouse.bHitActors=true;
M.enableMidLayer();


if (Parent.IsA('Pawn'))
 {
 foreach AllActors(class'MSBNodeButton',N)
   if (N.Order.IsA('MSBRootNode') && MSBRootNode(N.Order).BasePawn==Pawn(Parent))
     MSBRootNode(N.Order).initialLocation=Parent.Location;
 Log("isPawn!");
 }
if (Parent.IsA('MSBSpritePawn'))
 {
 foreach AllActors(class'MSBNodeButton',N)
   if (MSBSpriteNode(N.Order).BasePawn==MSBSpritePawn(Parent))
     MSBSpriteNode(N.Order).initialLocation=Mouse.selectedActor[i].Location;
 }
if (Parent.IsA('MSBCamera'))
  MSBCamera(Parent).initialLocation=Parent.Location;

}

DefaultProperties
{
BtnName="Scale"
Mat=Material'MovieSandboxTextures.icon_size'
widthRel=32
heightRel=32
bDisplayName=false
}
