//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBPropertyButtonSetAnimSet extends MSBPropertyButtonText;

var name WallDodgeAnims[4];
var name IdleHeavyAnim;
var name IdleRifleAnim;
var name FireHeavyRapidAnim;
var name FireHeavyBurstAnim;
var name FireRifleRapidAnim;
var name FireRifleBurstAnim;
var name MovementAnims[4];		// Forward, Back, Left, Right
var name TurnLeftAnim;
var name TurnRightAnim;			// turning anims when standing in place (scaled by turn speed)
var name SwimAnims[4];      // 0=forward, 1=backwards, 2=left, 3=right
var name CrouchAnims[4];
var name WalkAnims[4];
var name AirAnims[4];
var name TakeoffAnims[4];
var name LandAnims[4];
var name DoubleJumpAnims[4];
var name DodgeAnims[4];
var name AirStillAnim;
var name TakeoffStillAnim;
var name CrouchTurnRightAnim;
var name CrouchTurnLeftAnim;
var name IdleCrouchAnim;
var name IdleSwimAnim;
var name IdleWeaponAnim;    // WeaponAttachment code will set this one
var name IdleRestAnim;
var name IdleChatAnim;


function LeftBtnFinished(Canvas C)
{
local Mesh newMesh, oldMesh;

Mouse.TextInput="";

newMesh=Mesh(DynamicLoadObject(Value,class'Mesh',true));
oldMesh=MSBRootNode(MSBNodeButton(Parent).Order).BasePawn.Mesh;
if (newMesh!=None)
  {
  MSBRootNode(MSBNodeButton(Parent).Order).BasePawn.LinkMesh(newMesh,false);
  MSBRootNode(MSBNodeButton(Parent).Order).BasePawn.SetMesh();
  MSBRootNode(MSBNodeButton(Parent).Order).BasePawn.LinkMesh(oldMesh,true);
  MSBRootNode(MSBNodeButton(Parent).Order).BasePawn.SetMesh();
  SetDefaultAnimNames();
  TweenAnim(xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).IdleRestAnim,0.0);
  }
else
  Value="failed!";

super.LeftBtnFinished(C);
}

function SetDefaultAnimNames()
{
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).IdleRestAnim=IdleRestAnim;
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).AirStillAnim=AirStillAnim;

  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).AirAnims[0]=AirAnims[0];
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).AirAnims[1]=AirAnims[1];
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).AirAnims[2]=AirAnims[2];
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).AirAnims[3]=AirAnims[3];

  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).TakeoffStillAnim=TakeoffStillAnim;

  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).TakeoffAnims[0]=TakeoffAnims[0];
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).TakeoffAnims[1]=TakeoffAnims[1];
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).TakeoffAnims[2]=TakeoffAnims[2];
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).TakeoffAnims[3]=TakeoffAnims[3];

  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).LandAnims[0]=LandAnims[0];
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).LandAnims[1]=LandAnims[1];
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).LandAnims[2]=LandAnims[2];
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).LandAnims[3]=LandAnims[3];

  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).DoubleJumpAnims[0]=DoubleJumpAnims[0];
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).DoubleJumpAnims[1]=DoubleJumpAnims[1];
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).DoubleJumpAnims[2]=DoubleJumpAnims[2];
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).DoubleJumpAnims[3]=DoubleJumpAnims[3];

  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).DodgeAnims[0]=DodgeAnims[0];
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).DodgeAnims[1]=DodgeAnims[1];
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).DodgeAnims[2]=DodgeAnims[2];
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).DodgeAnims[3]=DodgeAnims[3];

//WallDodgeAnims[0]
//WallDodgeAnims[1]
//WallDodgeAnims[2]
//WallDodgeAnims[3]
//CrouchTurnRightAnim
//CrouchTurnLeftAnim


  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).IdleRestAnim=IdleRestAnim;
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).IdleCrouchAnim=IdleCrouchAnim;
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).IdleSwimAnim=IdleSwimAnim;
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).IdleWeaponAnim=IdleWeaponAnim;
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).IdleHeavyAnim=IdleHeavyAnim;
  xPawn(MSBRootNode(MSBNodeButton(Parent).Order).BasePawn).IdleRifleAnim=IdleRifleAnim;
}

defaultproperties
{
BtnName="AnimSet"
tooltip2="Type in Value"
assignProperty=false


    MovementAnims(0)=RunF
    MovementAnims(1)=RunB
    MovementAnims(2)=RunL
    MovementAnims(3)=RunR
    SwimAnims(0)=SwimF
    SwimAnims(1)=SwimB
    SwimAnims(2)=SwimL
    SwimAnims(3)=SwimR
    CrouchAnims(0)=CrouchF
    CrouchAnims(1)=CrouchB
    CrouchAnims(2)=CrouchL
    CrouchAnims(3)=CrouchR
    WalkAnims(0)=WalkF
    WalkAnims(1)=WalkB
    WalkAnims(2)=WalkL
    WalkAnims(3)=WalkR
    AirStillAnim=Jump_Mid
    AirAnims(0)=JumpF_Mid
    AirAnims(1)=JumpB_Mid
    AirAnims(2)=JumpL_Mid
    AirAnims(3)=JumpR_Mid
    TakeoffStillAnim=Jump_Takeoff
    TakeoffAnims(0)=JumpF_Takeoff
    TakeoffAnims(1)=JumpB_Takeoff
    TakeoffAnims(2)=JumpL_Takeoff
    TakeoffAnims(3)=JumpR_Takeoff
    LandAnims(0)=JumpF_Land
    LandAnims(1)=JumpB_Land
    LandAnims(2)=JumpL_Land
    LandAnims(3)=JumpR_Land
    DoubleJumpAnims(0)=DoubleJumpF
    DoubleJumpAnims(1)=DoubleJumpB
    DoubleJumpAnims(2)=DoubleJumpL
    DoubleJumpAnims(3)=DoubleJumpR
    DodgeAnims(0)=DodgeF
    DodgeAnims(1)=DodgeB
    DodgeAnims(2)=DodgeL
    DodgeAnims(3)=DodgeR
    WallDodgeAnims(0)=WallDodgeF
    WallDodgeAnims(1)=WallDodgeB
    WallDodgeAnims(2)=WallDodgeL
    WallDodgeAnims(3)=WallDodgeR

    TurnRightAnim=TurnR
    TurnLeftAnim=TurnL
    CrouchTurnRightAnim=Crouch_TurnR
    CrouchTurnLeftAnim=Crouch_TurnL
    IdleRestAnim=Idle_Rest
    IdleCrouchAnim=Crouch
    IdleSwimAnim=Swim_Tread
    IdleWeaponAnim=Idle_Rifle
    IdleHeavyAnim=Idle_Biggun
    IdleRifleAnim=Idle_Rifle
    IdleChatAnim=Idle_Chat
    FireHeavyRapidAnim=Biggun_Burst
    FireHeavyBurstAnim=Biggun_Aimed
    FireRifleRapidAnim=Rifle_Burst
    FireRifleBurstAnim=Rifle_Aimed
}



