//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBPropertyButtonPartsList extends MSBPropertyButton;

var array<String> ButtonList;
var array<String> Properties;
var array<MSBGuiOverlay> ListButton;

function LeftBtn(Canvas C)
{
local int i;
super.LeftBtn(C);

for (i=0;i<M.SaveCharParts.length; i++)
  {
    ListButton[i]=Spawn(class'MSBPropertyButtonAssign',self,,M.Location);
    ListButton[i].xPos=xpos+width;
     if (i>0)
      {                          //horizontal alignment
      ListButton[i].yPos=ListButton[i-1].ypos+ListButton[i-1].height+2;
      if (ListButton[i].yPos+ListButton[i].height>C.ClipY && ListButton[i].height<60)
        ListButton[i].ypos=yPos-(i*ListButton[i].height+height+2);
      }
    else
      ListButton[i].yPos=ypos;
    ListButton[i].SubLevel=SubLevel+1;
    MSBPropertyButton(ListButton[i]).Parent=self;
    MSBPropertyButton(ListButton[i]).BtnName=M.SaveCharParts[i];
  }
LeftBtnFinished(C);
}

event Trigger(Actor Other,Pawn EventInstigator)
{
local int i;

for (i=0;i<ListButton.length;i++)
  if (Other==ListButton[i])
    {
    if (Parent.IsA('MSBMasterBlock'))
      LoadPart(MSBMasterBlock(Parent),i);
    }
}

function MouseOver(Canvas C)
{
super.MouseOver(C);
C.SetPos(xpos+width,ypos);
if (Parent.IsA('MSBNodeButton'))
  C.DrawText(MSBNodeButton(Parent).Order.GetPropertyText(Property));
if (Parent.IsA('MSBPropertyButtonPad'))
  C.DrawText(MSBPawn(MSBPropertyButtonPad(Parent).Parent).PoseName[int(BtnName)-1]);

}


function LoadPart(MSBMasterBlock Master, int Part)
{
local MSBBlockCloud cloud;
local int i;
local class <MSBVoxelShader> shaderclass;
local string loadName;

//get rid of old blocks
loadname=M.SaveCharParts[Part];
Master.clearBlocks();
cloud=Level.Game.LoadDataObject(class'MSBBlockCloud',loadName,"MSBVoxPart_"$loadName);
for (i=0;i<cloud.Col.length;i++)
  {
  Master.S[i]=Spawn(class'MSBsimpleBlock',,,Master.Location);
  Master.S[i].bEdit=true;
  Master.S[i].SetDrawScale(cloud.drawScale[i]);
  Master.S[i].Skins[0]=new() class'ColorModifier';
  ColorModifier(Master.S[i].Skins[0]).Color=cloud.Col[i];
  ColorModifier(Master.S[i].Skins[0]).Material=ColorModifier(Master.Skins[0]).Material;
  Master.AttachToBone(Master.S[Master.S.length-1],'');
  Master.S[i].SetRotation(Master.Rotation);
  Master.S[i].setRelativeLocation(cloud.BlockRelLocation[i]);// >> Master.Rotation);
  Master.S[i].Master=Master;
  if (cloud.blockShader[i]!="")
    {
    shaderClass=class<MSBVoxelShader>(DynamicLoadObject(cloud.blockShader[i],class'Class'));
    Master.S[i].shader= new shaderClass;
    Master.S[i].shader.Parent=Master.S[i];
    Log(Master.S[i].shader);
    }
  }
}


DefaultProperties
{
Col=(R=128,G=64,B=64)
}
