class MSBVoxelEdController extends MSBController;

//voxel related
var MSBDrawBrush DrawBrush;                         //the "Pen"
var MSBRulerPlane Ruler;                            //ruler plane to draw in 3D
var MSBVoxelEdPawn myReferencePawn;                 //reference Character to draw upon

var float drawPosX,drawPosY,oldMouseX,oldMouseY;    //positioning of cursors when drawing

var config color colorfields[8];                    //remember the color in the swatches
var int colorPos;

var int currentCharacter;

var bool bFaceMode;
var vector faceVect, faceRulerSize, faceRulerVect;
var rotator FaceRot;

var vector normVect, normRulerSize, normRulerVect;
var rotator normRot;


event PostBeginPlay()
{
super.PostBeginPlay();
//get rid of context buttons
ContextButtonList.remove(0,ContextButtonList.Length);

//set up DrawBrush
initialSetup();

refreshMasters();

//hackery deluxe:
SetTimer(0.5,false);
}

function Timer()
{
switchMouth();
switchMouth();
}

//creating the pawn, the ruler and the pen and connecting everything together
function initialSetup()
{
local float flGridSpc;

//spawn DrawBrush
DrawBrush=Spawn(class'MSBDrawBrush',self);
flGridSpc=GridSpacing;
drawBrush.SetDrawScale(flGridSpc/8);
//spawn Ruler Plane here!
Ruler=Spawn(class'MSBRulerPlane',self,,normRulerVect);
Ruler.SetRotation(rot(32768,0,0));

//spawn MSBPawn
myReferencePawn=Spawn(class'MSBVoxelEdPawn');
myReferencePawn.SetPhysics(PHYS_None);
myReferencePawn.SetRotation(rot(0,0,0));

SetLocation(normVect);
}

function connectColorSwitches(MSBMenuBrushColorButton mc)
{
mc.col=colorfields[colorPos];
mc.position=colorPos++;
}

//moves the pen when drawing and determines drawing when button down
state CharacterEditor
{
  function PlayerTick(float DeltaTime)
  {
  global.PlayerTick(DeltaTime);
  //2D Positioning
  if (Mouse!=None && !Mouse.bTyping)
   {
    Mouse.xPos+=DeltaTime*MouseSens*aMouseX+aStrafe/6000;
    Mouse.yPos-=DeltaTime*MouseSens*aMouseY+aForward/6000;
   }

  if ((Mouse!=None && Mouse.hudTargetActor!=None) || (Mouse!=None && Mouse.worldMSBTargetActor==None))
    Mouse.bContained=false;
  else if (Mouse!=None)
    {
    Mouse.bContained=true;
    DrawBrush.SetLocation(Mouse.Mouse3D+ 3*Normal(Mouse.traceEnd));
    if(!Mouse.bShiftDown && drawBrush.Master!=None)
      {
      drawBrush.Master.Skins[0]=drawBrush.Master.Skins[2];
      if (!bFaceMode)
        determineMaster(DrawBrush.Location);
      else
        determineMasterFace(DrawBrush.Location);
      drawBrush.Master.Skins[0]=drawBrush.Master.Skins[1];
      }
    if(Mouse.btnOneDown)
      DrawBrush.draw();
    if(Mouse.btnTwoDown)
      DrawBrush.erase();
   }
  }

Begin:
 if (MInteract==None)
   {
   Player.InteractionMaster.AddInteraction("MSBCode.MSBInteraction", Player);
   bHasInteraction=true;
   Mouse=MSBHud(myHud).MouseOverlay;
   MInteract.Mouse=MSBHud(myHud).MouseOverlay;
   Log("PlayerController spawns an Interaction");
   }
determineMaster(DrawBrush.Location);
//debug
}


//switches between Drawing and selecting mode
exec function RunMovie();


//switches to flying mode and back
exec function switchStates()
{
bMove=!bMove;
if (bMove)
  GotoState('BaseSpectating');
else
  GotoState('CharacterEditor');
}

//left/right MouseButton press override
exec function pressedLeft();
exec function pressedRight();

exec function refreshMasters()
{
local int i;

for (i=0;i<myReferencePawn.Blocks.length;i++)
  if (myReferencePawn.Blocks[i]!=None)
    {
    myReferencePawn.Blocks[i].SetDrawScale3D(myReferencePawn.Blocks[i].edScale);
    myReferencePawn.Blocks[i].SetDrawType(DT_StaticMesh);
    }
}

function determineMaster(vector loc)
{
if(loc.Z>=27)
 {
 drawBrush.Master=myReferencePawn.Blocks[25];
 debugString="SelectedBone: Head"@25;
 }
if(loc.Z<27 && loc.Z>=24)
 {
 drawBrush.Master=myReferencePawn.Blocks[5];
 debugString="SelectedBone: Neck"@5;
 }

if(loc.Z<24 && loc.Z>=19)
 {
 drawBrush.Master=myReferencePawn.Blocks[4];
 debugString="SelectedBone: upper Spine"@4;
 }

if(loc.Z<19 && loc.Z>=13)
 {
 drawBrush.Master=myReferencePawn.Blocks[3];
 debugString="SelectedBone: middle Spine"@3;
 }

if(loc.Z<13 && loc.Z>=0)
 {
 drawBrush.Master=myReferencePawn.Blocks[2];
 debugString="SelectedBone: lower Spine"@2;
 }

//right leg
if(loc.Z<0 && loc.Z>=-14 && loc.Y>=0)
 {
 drawBrush.Master=myReferencePawn.Blocks[17];
 debugString="SelectedBone: right Thigh"@17;
 }

if(loc.Z<-14 && loc.Z>=-36 && loc.Y>=0)
 {
 drawBrush.Master=myReferencePawn.Blocks[18];
 debugString="SelectedBone: right Calf"@18;
 }

 //left leg
if(loc.Z<0 && loc.Z>=-14 && loc.Y<0)
 {
 drawBrush.Master=myReferencePawn.Blocks[21];
 debugString="SelectedBone: left Thigh"@21;
 }

if(loc.Z<-14 && loc.Z>=-36 && loc.Y<0)
 {
 drawBrush.Master=myReferencePawn.Blocks[22];
 debugString="SelectedBone: left Calf"@22;
 }


//right Arm
if(loc.Z>24 && loc.Z<27 && loc.Y>1)
 {
 drawBrush.Master=myReferencePawn.Blocks[6];
 debugString="SelectedBone: right Shoulder"@6;
 }

if(loc.Z>13 && loc.Y>7 && loc.Y<=16)
 {
 drawBrush.Master=myReferencePawn.Blocks[7];
 debugString="SelectedBone: right upper Arm"@7;
 }

if(loc.Y>16)
 {
 drawBrush.Master=myReferencePawn.Blocks[8];
 debugString="SelectedBone: right lower Arm"@8;
 }

if(loc.Y>24)
 {
 drawBrush.Master=myReferencePawn.Blocks[9];
 debugString="SelectedBone: right Hand"@9;
 }


//left Arm
if(loc.Z>24 && loc.Z<27 && loc.Y<-1)
 {
 drawBrush.Master=myReferencePawn.Blocks[12];
 debugString="SelectedBone: left Shoulder"@12;
 }

if(loc.Z>13 && loc.Y<-7 && loc.Y>=-16)
 {
 drawBrush.Master=myReferencePawn.Blocks[13];
 debugString="SelectedBone: left upper Arm"@13;
 }

if(loc.Y<-16)
 {
 drawBrush.Master=myReferencePawn.Blocks[14];
 debugString="SelectedBone: left lower Arm"@14;
 }

if(loc.Y<-24)
 {
 drawBrush.Master=myReferencePawn.Blocks[15];
 debugString="SelectedBone: left Hand"@15;
 }

}


function determineMasterFace(vector loc)
{
local int fb;
//set upper
if (loc.Y<0.75) fb=0;
if (loc.Y<-0.5) fb=1;
if (loc.Y<-1.5) fb=2;
debugstring="SelectedBone: upper Lip";
//upper lower switch
if (loc.Z<36.5)
  {
  fb+=4;
  debugstring="SelectedBone: lower Lip";
  }

//lip corners
if (loc.Y>0.75) fb=3;
if (loc.Y<-2) fb=7;


drawBrush.Master=myReferencePawn.FaceBlocks[fb];
}

exec function switchMouth()
{
bFaceMode=!bFaceMode;
if (bFaceMode)
  {
  SetLocation(faceVect);
  SetRotation(faceRot);
  Ruler.SetLocation(faceRulerVect);
  Ruler.SetDrawScale3D(faceRulerSize);
  SpectateSpeed=10;
 //becoz t-pose is fucked up
  myReferencePawn.LinkMesh(myReferencePawn.UTMesh2);
  myReferencePawn.getFace();
  }
else
  {
  SetLocation(normVect);
  SetRotation(normRot);
  Ruler.SetLocation(normRulerVect);
  Ruler.SetDrawScale3D(normRulerSize);
  SpectateSpeed=100;
 //becoz t-pose is fucked up
  myReferencePawn.undoFaceBlocks();
  myReferencePawn.LinkMesh(myReferencePawn.UTMesh);
  }
myReferencePawn.channel=1;
myReferencePawn.Trigger(self,None);
}


defaultproperties
{
Gridspacing=2
faceVect=(X=132,Y=-4,Z=40)
faceRot=(Yaw=30000);
faceRulerSize=(X=0.25,Y=0.25,Z=0.25);
faceRulerVect=(X=110,Y=-0.5,Z=40)

normVect=(X=175,Y=0,Z=10);
normRot=(Yaw=32768);
normRulerSize=(X=1,y=-4,Z=4)
normRulerVect=(X=108,Y=0,Z=0);
}
