//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBPropertyButtonMoveBlocks extends MSBPropertyButton;

var vector chgLocAbs,
           xAxis,
           yAxis,
           zAxis;

var float oldX,
          oldY;

var bool bShift;
var EPhysics OldPhysics;
var float dTime;

function Tick(float DeltaTime)
{
super.Tick(DeltaTime);
dTime=DeltaTime;
}

function Render(Canvas C)
{
local vector chgLoc;
local int i;

super.Render(C);
if (bEnabled)
 {
  if (bDragged)
    {
    if (bShift)
      chgLoc.Z=-(Mouse.yPos-oldY);
    else
      chgLoc=yAxis*(Mouse.xPos-oldX)-xAxis*(Mouse.yPos-oldY);

    if (M.bGrid)
      {
      chgLoc*=dTime*M.Gridspacing/2*10;
      if (chgLocAbs.X>M.GridSpacing || chgLocAbs.Y>M.GridSpacing || chgLocAbs.Z>M.GridSpacing || chgLocAbs.X<-M.GridSpacing || chgLocAbs.Y<-M.GridSpacing ||chgLocAbs.Z<-M.GridSpacing)
        {
        M.calculateGrid(chgLocAbs);
        if (MSBMasterBlock(Mouse.lastSelectedActor).S.length>0)
          for (i=0; i<MSBMasterBlock(Mouse.lastSelectedActor).S.length;i++)
            MSBMasterBlock(Mouse.lastSelectedActor).S[i].iniRelLocation=MSBMasterBlock(Mouse.lastSelectedActor).S[i].iniRelLocation+chgLocAbs;
        else
          M.warningmessage("Master Block is empty!"@"\n"@Mouse.lastSelectedActor@"\n"@Mouse.hudTargetActor);
        chgLocAbs=chgLocAbs*0;
        }
      else
        chgLocAbs+=chgLoc;
      }
    else
      {
      chgLoc=chgLoc*dTime*80;
        if (MSBMasterBlock(Mouse.lastSelectedActor).S.length>0)
          for (i=0; i<MSBMasterBlock(Mouse.lastSelectedActor).S.length;i++)
            MSBMasterBlock(Mouse.lastSelectedActor).S[i].iniRelLocation=MSBMasterBlock(Mouse.lastSelectedActor).S[i].iniRelLocation+chgLocAbs;
        else
          M.warningmessage("Master Block is empty!"@"\n"@Mouse.lastSelectedActor@"\n"@Mouse.hudTargetActor);
      }

    Mouse.xPos=oldX;
    Mouse.yPos=oldY;
    }

 if (hasClicked && Mouse.btnOne)
    {
    hasClickedAgain=true;
    LeftBtnFinished(C);
    hasClickedAgain=false;
    }
 if (hasClicked && Mouse.bShiftDown && !bShift)
    PressShift(C);
 }

if (!Mouse.bShiftDown)
 bShift=false;
}

function PressShift(Canvas C)
{
bShift=true;
}



function LeftBtn(Canvas C)
{
super.LeftBtn(C);
bDragged=true;
Mouse.bHitActors=false;
oldX=Mouse.xPos;
oldY=Mouse.yPos;
GetAxes(M.Rotation,xAxis,yAxis,zAxis);
xAxis.Z=0;
yAxis.Z=0;
M.disableMidLayer();

if (MSBMasterBlock(Mouse.lastSelectedActor).S.length==0)
  {
  M.warningmessage("Master Block is empty!"@"/n"@Mouse.lastSelectedActor@"/n"@Mouse.lastSelectedActor);
  LeftBtnFinished(C);
  }
}

function LeftBtnFinished(Canvas C)
{
local int i;

Log("Finish!");
deselect();
//enable all other buttons after second press
for (i=0;i<M.myHud.Overlays.Length-1;i++)
  if (M.myHud.Overlays[i].IsA('MSBGuiOverlay'))
    MSBGuiOverlay(M.myHud.Overlays[i]).bEnabled=true;

Mouse.btnOne=false;
bDragged=false;

Mouse.bHitActors=true;
M.enableMidLayer();
}

DefaultProperties
{
BtnName="Move"
}
