//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBTracePropButton extends MSBPropertyButtonComplex
config (MSBCode);

//helping hands
var MSBPenWidget PW;
var MSBUdpLink udpLink;
var float stepsX, stepsY;

//stuff to adjust
var () config float brushSize;
var () config float depthSize;
var () vector startLoc;
var () vector Offset;


//stuff from outside
var int resolution;                                   //determines the number of steps per line
var int boneValue;                                    //determines which bone to link to
var byte red,green,blue, alpha, zValue;

function LeftBtn(Canvas C)
{
super.LeftBtn(C);
PW=MSBPenWidget(Parent);
}

function Trigger(Actor Other, Pawn EventInstigator)
{
if (Other==ListButton[ListButton.length-1])
  {
  Reset();
  PW=MSBPenWidget(Parent);
  if(udpLink==None)
    {
    udpLink= spawn(class'MSBUdpLink',self);
    udpLink.InitUdpLink(41840);
    }
  SaveConfig();
  }

if(Other==udpLink)
  {
  //get outside data
  startLoc=PW.Ruler.Location + PW.Ruler.DrawScale*Offset;

  alpha= udpLink.byteData[0];
  red=udpLink.byteData[1];
  green=udpLink.byteData[2];
  blue=udpLink.byteData[3];
  zValue=udpLink.byteData[4];
  resolution=udpLink.byteData[5]+1;
//  boneValue=udpLink.byteData[6];

  //do trace
  DoTrace();
  }
}

function DoTrace()
{
local vector currentLoc;
local color newCol;
local float factor;

//start traversing the ruler from top left to bottom right
if (stepsX>=resolution)
  {
  stepsY+=1;
  stepsX=0;
  }

//set Brush Properties
//location
factor=128/resolution;
currentLoc.Z=(stepsX*factor)+startloc.Z;
currentLoc.Y=(stepsY*factor)+startloc.Y;
currentLoc.X=startloc.X+float(zValue)/depthSize;
PW.DrawBrush.SetLocation(currentLoc);


//debug
PW.M.debugString=stepsx@stepsY@PW.Ruler.Location@currentLoc;

//color
newCol.R=red;
newCol.G=green;
newCol.B=blue;
PW.DrawBrush.myColor=newCol;

//size
PW.DrawBrush.SetDrawScale(brushSize);

if(zValue>0)
  {
  //paint;
  PW.DrawBrush.draw();
  }

stepsX+=1;
}

function Reset()
{
super.Reset();
stepsX=0;
stepsY=0;
}

event Destroyed()
{
super.Destroyed();
udpLink.Destroy();
}
//TODO: Destroy udp!


DefaultProperties
{
ButtonList(0)="MSBPropertyButtons.MSBPropertyButtonText"
ButtonProperty(0)="brushSize"
ButtonName(0)="brushSize"

ButtonList(1)= "MSBPropertyButtons.MSBPropertyButtonText"
ButtonProperty(1)="depthSize"
ButtonName(1)="depthSize"

ButtonList(2)="MSBPropertyButtons.MSBPropertyButtonAssign"
ButtonProperty(2)=""
ButtonName(2)="Start!"

tooltip1="Set Master Block"
tooltip2="Select Master Block"

BtnName="Trace"
listOrientation=2
widthRel=48
heightRel=48

boneValue=1


depthSize=8
brushSize=0.5
Offset=(X=0,Y=-64,Z=-64)
}
