//-----------------------------------------------------------
//     Grabs a BoneRotation via UDP
//-----------------------------------------------------------
class MSBPoseGetButton extends MSBTwoStepButton;

var string loadName;
var MSBPoseWidget Parent;
var MSBUDPLink udpLink;
var rotator absRot;
var() rotator appliedRotation;
var() vector getVect;
var() coords myCoords[25];
var () float blend;
var bool bInit;

event PostBeginPlay()
{
super.PostBeginPlay();
udpLink= spawn (class'MSBUdpLink',self);
udpLink.InitUdpLink(61840);
Log("We created a"@self);
}

function initButton(Canvas C)
{
super.initButton(C);

C.SetPos(xPos,yPos);
C.SetDrawColor(textCol.R,textCol.G,textCol.B);
C.DrawText(BtnName);
C.SetDrawColor(col.R,col.G,col.B);
}

function LeftBtnFinished(Canvas C)                      //spawns subButtons
{
udpLink.Destroy();
super.LeftBtnFinished(C);
}

function Trigger(Actor Other, Pawn EventInstigator)
{
local int i;
local float c,x,y,z;

super.Trigger(Other,EventInstigator);

if (!bInit)
{
for (i=1;i<26;i++)
  myCoords[i]=findBoneCoords(i);
bInit=true;
}

// boneNumber = int(i/3+1)

// Z and X are negative and Z and Y are swapped

/*
//spine part
for (i=2;i<6;i++)  //6
  {
  }
//right Arm part
for (i=7;i<10;i++)
  {
  }
//left Arm part
for (i=13;i<16;i++)
  {
  }
//right leg
for (i=17;i<20;i++)
  {
  }
//left leg
for (i=21;i<24;i++)
  {
  }
*/

getVect.X=udpLink.byteData[7*3-3] - 128;
getVect.Y=udpLink.byteData[7*3-2] - 128;
getVect.Z=udpLink.byteData[7*3-1] - 128;

x=getVect dot myCoords[7].XAxis;
y=getVect dot myCoords[7].YAxis;
z=getVect dot myCoords[7].ZAxis;

c=Sqrt((y * y)+(z * z));
appliedRotation.Pitch=Atan(c,x) * 32768/PI;
appliedRotation.Roll=Atan(z,y) * 32768/PI;

Log(Parent.PoseActor@appliedRotation@"C:"@c@getVect);

//setBone(appliedRotation,7);

appliedRotation.Yaw=8000;
Parent.PoseActor.setBoneRotation('Bip01 R UpperArm', appliedRotation, blend, 1);
}


//finds the parent bone to the bonenumber set in i
function int findParent(int i)
{
//spine
if (i>0 && i<6) return i-1;

//right arm
if (i==7) return 5;
if (i>7 && i<11) return i-1;

//left arm
if (i==13) return 5;
if (i>13 && i<17) return i-1;

//right leg
if (i==17) return 1;
if (i>17 && i<21) return i-1;

//right leg
if (i==21) return 1;
if (i>21 && i<25) return i-1;

//head
if (i==25) return 5;
}

function setBone(rotator receivedRot, int boneNumber)
{
Parent.Pose.PoseKey[boneNumber].BoneRotation=receivedRot;
Parent.Pose.PoseKey[boneNumber].KeyActor=Parent.PoseActor;
Parent.Pose.PoseKey[boneNumber].changeBoneRotation();
}

function rotator getABSBoneRot(int boneNumber)
{
return Parent.Pose.PoseKey[boneNumber].GetBoneRotationUTSkel();
}

function coords findBoneCoords(int boneNumber)
{
return Parent.Pose.PoseKey[boneNumber].GetBoneCoordsUTSkel();
}

DefaultProperties
{
widthRel=74
heightRel=24
BtnName="GetPose"
tooltip1="get Pose Data"
tooltip2="waiting for Pose Data"
}
